# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AuthAuthorizeBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'grant_type': 'str',
        'refresh_token': 'str',
        'code': 'str',
        'state': 'str',
        'redirect_uri': 'str',
        'client_id': 'str',
        'client_secret': 'str',
        'scope': 'str',
        'org_id': 'str'
    }

    attribute_map = {
        'grant_type': 'grant_type',
        'refresh_token': 'refresh_token',
        'code': 'code',
        'state': 'state',
        'redirect_uri': 'redirect_uri',
        'client_id': 'client_id',
        'client_secret': 'client_secret',
        'scope': 'scope',
        'org_id': 'orgId'
    }

    def __init__(self, grant_type=None, refresh_token=None, code=None, state=None, redirect_uri=None, client_id=None, client_secret=None, scope=None, org_id=None):  # noqa: E501
        """AuthAuthorizeBody - a model defined in Swagger"""  # noqa: E501
        self._grant_type = None
        self._refresh_token = None
        self._code = None
        self._state = None
        self._redirect_uri = None
        self._client_id = None
        self._client_secret = None
        self._scope = None
        self._org_id = None
        self.discriminator = None
        self.grant_type = grant_type
        if refresh_token is not None:
            self.refresh_token = refresh_token
        if code is not None:
            self.code = code
        self.state = state
        if redirect_uri is not None:
            self.redirect_uri = redirect_uri
        if client_id is not None:
            self.client_id = client_id
        if client_secret is not None:
            self.client_secret = client_secret
        if scope is not None:
            self.scope = scope
        if org_id is not None:
            self.org_id = org_id

    @property
    def grant_type(self):
        """Gets the grant_type of this AuthAuthorizeBody.  # noqa: E501

        The type of authorization to be performed.  # noqa: E501

        :return: The grant_type of this AuthAuthorizeBody.  # noqa: E501
        :rtype: str
        """
        return self._grant_type

    @grant_type.setter
    def grant_type(self, grant_type):
        """Sets the grant_type of this AuthAuthorizeBody.

        The type of authorization to be performed.  # noqa: E501

        :param grant_type: The grant_type of this AuthAuthorizeBody.  # noqa: E501
        :type: str
        """
        if grant_type is None:
            raise ValueError("Invalid value for `grant_type`, must not be `None`")  # noqa: E501

        self._grant_type = grant_type

    @property
    def refresh_token(self):
        """Gets the refresh_token of this AuthAuthorizeBody.  # noqa: E501

        The refresh token when <code>grant_type</code> is set to <code>refresh_token</code>  # noqa: E501

        :return: The refresh_token of this AuthAuthorizeBody.  # noqa: E501
        :rtype: str
        """
        return self._refresh_token

    @refresh_token.setter
    def refresh_token(self, refresh_token):
        """Sets the refresh_token of this AuthAuthorizeBody.

        The refresh token when <code>grant_type</code> is set to <code>refresh_token</code>  # noqa: E501

        :param refresh_token: The refresh_token of this AuthAuthorizeBody.  # noqa: E501
        :type: str
        """

        self._refresh_token = refresh_token

    @property
    def code(self):
        """Gets the code of this AuthAuthorizeBody.  # noqa: E501

        The authorization code when <code>grant_type</code> is set to <code>authorization_code</code>  # noqa: E501

        :return: The code of this AuthAuthorizeBody.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this AuthAuthorizeBody.

        The authorization code when <code>grant_type</code> is set to <code>authorization_code</code>  # noqa: E501

        :param code: The code of this AuthAuthorizeBody.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def state(self):
        """Gets the state of this AuthAuthorizeBody.  # noqa: E501

        A transparent state of the request.  # noqa: E501

        :return: The state of this AuthAuthorizeBody.  # noqa: E501
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this AuthAuthorizeBody.

        A transparent state of the request.  # noqa: E501

        :param state: The state of this AuthAuthorizeBody.  # noqa: E501
        :type: str
        """
        if state is None:
            raise ValueError("Invalid value for `state`, must not be `None`")  # noqa: E501

        self._state = state

    @property
    def redirect_uri(self):
        """Gets the redirect_uri of this AuthAuthorizeBody.  # noqa: E501

        The URI to which a redirect will be performed upon successful authorization.  # noqa: E501

        :return: The redirect_uri of this AuthAuthorizeBody.  # noqa: E501
        :rtype: str
        """
        return self._redirect_uri

    @redirect_uri.setter
    def redirect_uri(self, redirect_uri):
        """Sets the redirect_uri of this AuthAuthorizeBody.

        The URI to which a redirect will be performed upon successful authorization.  # noqa: E501

        :param redirect_uri: The redirect_uri of this AuthAuthorizeBody.  # noqa: E501
        :type: str
        """

        self._redirect_uri = redirect_uri

    @property
    def client_id(self):
        """Gets the client_id of this AuthAuthorizeBody.  # noqa: E501

        The client ID when <code>grant_type</code> is set to <code>client_credentials</code>. Will be ignored if the <code>Authorization</code> header is set.  # noqa: E501

        :return: The client_id of this AuthAuthorizeBody.  # noqa: E501
        :rtype: str
        """
        return self._client_id

    @client_id.setter
    def client_id(self, client_id):
        """Sets the client_id of this AuthAuthorizeBody.

        The client ID when <code>grant_type</code> is set to <code>client_credentials</code>. Will be ignored if the <code>Authorization</code> header is set.  # noqa: E501

        :param client_id: The client_id of this AuthAuthorizeBody.  # noqa: E501
        :type: str
        """

        self._client_id = client_id

    @property
    def client_secret(self):
        """Gets the client_secret of this AuthAuthorizeBody.  # noqa: E501

        The client secret when <code>grant_type</code> is set to <code>client_credentials</code>. Will be ignored if the <code>Authorization</code> header is set.  # noqa: E501

        :return: The client_secret of this AuthAuthorizeBody.  # noqa: E501
        :rtype: str
        """
        return self._client_secret

    @client_secret.setter
    def client_secret(self, client_secret):
        """Sets the client_secret of this AuthAuthorizeBody.

        The client secret when <code>grant_type</code> is set to <code>client_credentials</code>. Will be ignored if the <code>Authorization</code> header is set.  # noqa: E501

        :param client_secret: The client_secret of this AuthAuthorizeBody.  # noqa: E501
        :type: str
        """

        self._client_secret = client_secret

    @property
    def scope(self):
        """Gets the scope of this AuthAuthorizeBody.  # noqa: E501

        Currently not supported. Present for CSP compatibility.  # noqa: E501

        :return: The scope of this AuthAuthorizeBody.  # noqa: E501
        :rtype: str
        """
        return self._scope

    @scope.setter
    def scope(self, scope):
        """Sets the scope of this AuthAuthorizeBody.

        Currently not supported. Present for CSP compatibility.  # noqa: E501

        :param scope: The scope of this AuthAuthorizeBody.  # noqa: E501
        :type: str
        """

        self._scope = scope

    @property
    def org_id(self):
        """Gets the org_id of this AuthAuthorizeBody.  # noqa: E501

        When <code>grant_type</code> is set to <code>client_credentials</code> if this parameter is set the issued token will be limited to the specified organization.  # noqa: E501

        :return: The org_id of this AuthAuthorizeBody.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this AuthAuthorizeBody.

        When <code>grant_type</code> is set to <code>client_credentials</code> if this parameter is set the issued token will be limited to the specified organization.  # noqa: E501

        :param org_id: The org_id of this AuthAuthorizeBody.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AuthAuthorizeBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AuthAuthorizeBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
